<?php
/*
|--------------------------------------------------------------------------
| file_tag
|--------------------------------------------------------------------------
*/

return array
(
    # 表名
    'name' => 'file_tag',
    # 显示给用户看的名称
    'lang' => '资源标签关联表',
    'menu' => false,

    # 数据结构
    'struct' => array
    (
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            'list'      => true,
        ),
        
        'file_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '文件id',
            'default'   => '',
            'desc'      => '文件id',
            'match'     => 'is_numeric',
            'update'    => 'text',
            'list'      => true,
        ),

        'tag_id'       => array
        (
            'type'      => 'int-11',
            'name'      => '标签id',
            'default'   => '',
            'desc'      => '标签id',
            'match'     => 'is_numeric',
            'update'    => 'text',
            'list'      => true,
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '录入时间',
            'match'     => array('is_numeric', DEVER_TIME),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            'list'      => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),

    # request 请求接口定义
    'request' => array
    (
        
    )
);
