<?php

return array
(
    # 表名
    'name' => 'import',
    # 显示给用户看的名称
    'lang' => '导入',
    'menu' => false,
    'end' => array
    (
        'insert' => 'upload/lib/manage.import',
    ),
    # 数据结构
    'struct' => array
    (
    
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            'list'        => true,
        ),

        'file'      => array
        (
            'type'      => 'varchar-150',
            'name'      => '选择导入文件',
            'default'   => '',
            'desc'      => '选择导入文件',
            'match'     => 'option',
            'update'    => 'upload',
            'key'       => Dever::input('key', 4),
        ),

        'call'      => array
        (
            'type'      => 'varchar-800',
            'name'      => 'call',
            'default'   => '',
            'desc'      => '选择导入文件',
            'match'     => 'option',
            'update'    => 'hidden',
            'value'     => Dever::input('call'),
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '创建时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            //'search'  => 'date',
            'list'      => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),

    'manage' => array
    (
        //'excel'   => true,
        //'delete' => false,
        //'edit' => false,
        //'insert' => false,
    ),
);
