<?php

return array
(
    # 表名
    'name' => 'tag',
    # 显示给用户看的名称
    'lang' => '标签管理',
    'order' => 1,
    'menu' => false,
    # 数据结构
    'struct' => array
    (
    
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            //'list'        => true,
        ),

        'name'      => array
        (
            'type'      => 'varchar-300',
            'name'      => '名称',
            'default'   => '',
            'desc'      => '名称',
            'match'     => 'option',
            'update'    => 'text',
            'list'      => true,
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '创建时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            //'search'  => 'date',
            'list'      => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),

    'manage' => array
    (
        //'excel'   => true,
        //'delete' => false,
        //'edit' => false,
        //'insert' => false,
    ),

    'request' => array
    (
        'getDataByIds' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'id' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('id' => 'desc'),
            'col' => '*',
        ),
        'search' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'name' => array('yes', 'like'),
                'id' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('id', 'desc'),
            'col' => '*,name as value,name as label|id',//这里为了做autocomplete进行测试，必须输出value和label
        ),
    )

);
